<?php
/* 
Plugin Name: WoW Guild Retrieve
Plugin URI: http://www.manatrance.com/
Description: Shows guild data for a World of Warcraft guild
Version: 1.0.1
Author: Ben Overmyer
Author URI: http://www.manatrance.com/
*/

/*  Copyright 2010  Ben_Overmyer  (email : manatrance@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
  

wp_enqueue_script('newscript','/wp-content/plugins/wow-guild-retrieve/js/jquery.dataTables.min.js',array('jquery') );
wp_enqueue_style('wgrstyle','/wp-content/plugins/wow-guild-retrieve/css/wgr.css');

function wgr_build_url($guild,$realm,$region) {
	$url = "";
	
	$guild = str_replace(' ','+',$guild);
	$realm = str_replace(' ','+',$realm);
	
	if ($region == 'us') {
		$url = 'http://www.wowarmory.com/guild-info.xml';
	} else {
		$url = 'http://eu.wowarmory.com/guild-info.xml';
	}
	
	$url .= '?r=' . stripslashes($realm) . '&n=' . $guild . '&p=1';
	
	return $url;
}

function wow_guild_retrieve($atts) {
	extract(shortcode_atts(array(
		'guildname' => '',
		'realmname' => '',
		'region' => 'us',
		'sorttype' => '1',
		'sortorder' => 'asc',
		'restrict' => 'false'
	), $atts));
	
	$widgetid = 'wgrtable' . rand(1,100);
	
    $url = wgr_build_url($guildname,$realmname,$region);

	$ch = curl_init($url);
	
	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.3) Gecko/20070309 Firefox/2.0.0.3");
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$output = curl_exec($ch);
	curl_close($ch);
		
	$parser = xml_parser_create();
	xml_parse_into_struct($parser, $output,$vals,$index);
	xml_parser_free($parser);

	if (!$index) {
		$content = "Unable to contact Armory.";
	} else {
		$content .= '<script type="text/javascript">';
		$content .= 'jQuery(document).ready(function() ';
		$content .= '{'; 
        $content .= 'jQuery("#' . $widgetid . '").dataTable().fnSort([[' . $sorttype . ',"' . $sortorder . '"]]);';
		$content .= '}'; 
		$content .= ');';
		$content .= '</script>';
		$content .= '<div id="guild-data-div">';
		$content .= '<div id="header-block">';
		
		$ginfo_index = $index["GUILDHEADER"]["0"];
		$ginfo = $vals[$ginfo_index]["attributes"];	
		$gname = $ginfo["NAME"];
		$gfaction = $ginfo["FACTION"];
		$minfo_index = $index["MEMBERS"]["0"];
		$minfo = $vals[$minfo_index]["attributes"];
		$gmembers = $minfo["MEMBERCOUNT"];
		
		$content .= '<img src="' . WP_PLUGIN_URL . '/wow-guild-retrieve/images/faction-' . $gfaction . '.png" alt="" height="64" width="64"/>';
		$content .= '<div id="header-text">';
		$content .= '<h2>' . $gname . '</h2>';
		$content .= '<h3>' . $gmembers . ' members</h3>';
		$content .= '</div>';
		$content .= '<div class="clear"></div>';
		$content .= '</div>';
		$content .= "<table id='$widgetid' class='dataTable'>\n";
		$content .= "<thead><tr><th class='ginfo-name'>Name</th><th class='ginfo-race'>Race</th><th class='ginfo-class'>Class</th><th class='ginfo-level'>Level</th><th class='ginfo-rank'>Rank</th></tr></thead>\n";
		$content .= "<tbody>\n";
		
		$whichrow = 0;
		
		foreach($index["CHARACTER"] as $characters) {
			$character = $vals[$characters]["attributes"];
			$raceid = $character["RACEID"];
			if ($raceid == '0') { $race = "Zero";
			} elseif ($raceid == '1') { $race = "Human";
			} elseif ($raceid == '2') { $race = "Orc";
			} elseif ($raceid == '3') { $race = "Dwarf";
			} elseif ($raceid == '4') { $race = "NightElf";
			} elseif ($raceid == '5') { $race = "Undead";
			} elseif ($raceid == '6') { $race = "Tauren";
			} elseif ($raceid == '7') { $race = "Gnome";
			} elseif ($raceid == '8') { $race = "Troll";
			} elseif ($raceid == '9') { $race = "Nine"; 
			} elseif ($raceid == '10') { $race = "BloodElf";
			} elseif ($raceid == '11') { $race = "Draenei";
			} else { $race = "Bork"; }
			
			$genderid = $character["GENDERID"];
			if ($genderid == '0') { $gender = "Male"; } else { $gender = "Female"; }
			
			$classid = $character["CLASSID"];
			if ($classid == '0') { $class = "Zero";
			} elseif ($classid == '1') { $class = "Warrior";
			} elseif ($classid == '2') { $class = "Paladin";
			} elseif ($classid == '3') { $class = "Hunter";
			} elseif ($classid == '4') { $class = "Rogue";
			} elseif ($classid == '5') { $class = "Priest";
			} elseif ($classid == '6') { $class = "DeathKnight";
			} elseif ($classid == '7') { $class = "Shaman";
			} elseif ($classid == '8') { $class = "Mage";
			} elseif ($classid == '9') { $class = "Warlock";
			} elseif ($classid == '10') { $class = "Ten";
			} elseif ($classid == '11') { $class = "Druid";
			} else { $class = "Bork"; }
			
			$raceimg = 'race-' . $race . '-' . $gender . '.png';
			$classimg = 'class-' . $class . '.png';
			if ($character["RANK"] == '0') { $rank = "Guild Leader"; } else { $rank = "Rank " . $character["RANK"]; }
			
			if (($restrict == 'true' AND $character["LEVEL"] == '80') OR ($restrict == 'false')){
				if ($whichrow == 0) {
					$rowstyle = "odd";
				} else {
					$rowstyle = "even";
				}
				$content .= "<tr class='$rowstyle'>";
				$content .= "<td class='ginfo-name'><a href='http://" . $region . ".wowarmory.com/character-sheet.xml?" . $character["URL"] . "'>" . $character["NAME"] . "</a></td><td class='ginfo-race'><img src='" . WP_PLUGIN_URL . "/wow-guild-retrieve/images/" . $raceimg . "' alt='" . $race . "' width='32' height='32'/></td><td class='ginfo-class'><img src='" . WP_PLUGIN_URL . "/wow-guild-retrieve/images/" . $classimg . "' alt='" . $class . "' width='32' height='32'/></td><td class='ginfo-level'>" . $character["LEVEL"] . "</td><td class='ginfo-rank'>" . $rank . "</td></tr>";
				$content .= "</tr>\n";
				$whichrow++;
				if ($whichrow >= 2) {
					$whichrow = 0;
				}
			}
		}
		$content .= "</tbody>";
		$content .= "</table>";
		$content .= "<div class='clear'></div>";
		$content .= "</div>";
	
	}
	
	return $content;
}

add_shortcode('wgr','wow_guild_retrieve');

?>